<?php
/*
Plugin Name: WP Rental SMS Register Plugin For Rangine.ir Gateway
Plugin URI: http://rangine.ir
Description: add rangine sms register to wprental theme.
Author: Hadi Mollaei
Version: 2.3
Author URI: http://rangine.ir
Domain Path: /lang
Text Domain: wprentals_sms
*/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

load_plugin_textdomain( 'wprentals_sms', false, dirname( plugin_basename( __FILE__ ) ) . '/lang/' );

add_action('setup_theme','load_sms_register_plugin');

function load_sms_register_plugin() {

	function wpestate_ajax_register_form(){
        $captcha = sanitize_text_field($_POST['capthca']);
        
        if(wprentals_get_option('wp_estate_use_captcha','')=='yes'){
            if(!isset($_POST['capthca']) || $_POST['capthca']==''){
                echo json_encode(array('register'=>false,'message'=>esc_html__( 'Please confirm you are not a robot!','wprentals_sms')));
                exit();
            }

            $secret    = wprentals_get_option('wp_estate_recaptha_secretkey','');
            
            global $wp_filesystem;
            if (empty($wp_filesystem)) {
                require_once (ABSPATH . '/wp-admin/includes/file.php');
                WP_Filesystem();
            }
            $response = $wp_filesystem->get_contents("https://www.google.com/recaptcha/api/siteverify?secret=".$secret."&response=".$captcha."&remoteip=".esc_html($_SERVER['REMOTE_ADDR']));


            if ($response['success'] == false) {
                echo json_encode(array('register'=>false,'message'=>esc_html__( 'Please confirm you are not a robot!','wprentals_sms')));
                exit();
            }
        }
       
        
        $allowed_html   =   array();
        $user_email  =   trim( wp_kses ($_POST['user_email_register'],$allowed_html ));
        $user_name   =   trim( wp_kses ($_POST['user_login_register'],$allowed_html ));
       
        if (preg_match("/^[0-9A-Za-z_]+$/", $user_name) == 0) {
            echo json_encode(array('register'=>false,'message'=>esc_html__( 'Invalid username (do not use special characters or spaces)!','wprentals_sms')));
            die();
        }
        
        
        if ($user_email=='' || $user_name==''){
            echo json_encode(array('register'=>false,'message'=>esc_html__( 'Username and/or Email field is empty!','wprentals_sms')));
            exit();
        }
		
		if ( !preg_match("/^09[0-9]{9}$/", $user_email) ) {
			echo json_encode(array('register'=>false,'message'=>esc_html__( 'The mobile doesn\'t look right!','wprentals_sms')));
            exit();
		}
		
		$args = array(
			'meta_key'		=> 'mobile',
			'meta_value'	=> $user_email,
		); 
		$user_mobile_exist = get_users( $args );
			
		if ( $user_mobile_exist && sizeof($user_mobile_exist) > 0 ) {
			echo json_encode(array('register'=>false,'message'=>esc_html__( 'Mobile already exists.  Please choose a new one!','wprentals_sms')));
            exit();
		}        
        
        $user_id     =   username_exists( $user_name );
        if ($user_id){
            echo json_encode(array('register'=>false,'message'=>esc_html__( 'Username already exists.  Please choose a new one.!','wprentals_sms')));
            exit();
        }
        
        $enable_user_pass_status=   esc_html ( wprentals_get_option('wp_estate_enable_user_pass','') );
        if($enable_user_pass_status=='yes' ){
            $user_pass              =   trim( sanitize_text_field(wp_kses( $_POST['user_pass'] ,$allowed_html) ) );
            $user_pass_retype       =   trim( sanitize_text_field(wp_kses( $_POST['user_pass_retype'] ,$allowed_html) ) );
        
            if ($user_pass=='' || $user_pass_retype=='' ){
                echo json_encode(array('register'=>false,'message'=>esc_html__( 'One of the password field is empty!','wprentals_sms')));
                exit();
            }
            
            if ($user_pass !== $user_pass_retype ){
                echo json_encode(array('register'=>false,'message'=>esc_html__( 'Passwords do not match!','wprentals_sms')));
                exit();
            }
        }
        
         
        if ( !$user_id ) {
           
            if($enable_user_pass_status=='yes' ){
                $random_password = $user_pass; // no so random now!
            }else{
		$random_password = rand(111111,999999);
                //$random_password = wp_generate_password( $length=12, $include_standard_special_chars=false );
            }
			
			$user_email_mail = $user_email.'@gmail.com';
            
            $user_id         = wp_create_user( $user_name, $random_password, $user_email_mail );
         
            
            rcapi_create_new_user($user_id,$user_name,$password,$user_email_mail);
            
            
            if ( is_wp_error($user_id) ){
               
            } else {
				
				update_user_meta($user_id, 'mobile', $user_email);
				
				//$sms_text = __('Your Password is: PASS','wprentals_sms');
				//$sms_text = str_replace('PASS', $random_password, $sms_text );
				$sitename = get_option('blogname');
				$sms_text = 'patterncode:berx4i716l;pass:'.$random_password.';company:'.$sitename;

				
				
				
				$sms_result = rangine_rental_send_sms_register($user_email, $sms_text);
                
                if(isset($_POST['user_type'])){
                    update_user_meta($user_id, 'user_type', intval($_POST['user_type']));
                }
                if($enable_user_pass_status=='yes' ){
                    echo json_encode(array('register'=>true,'message'=>esc_html__( 'The account was created. You can login now.','wprentals_sms')));
                }else{
                    echo json_encode(array('register'=>true,'message'=>esc_html__( 'A sms with the generated password was sent.','wprentals_sms')));
                }
                wpestate_update_profile($user_id);
                wpestate_wp_new_user_notification( $user_id, $random_password ) ;
                
                if(intval($_POST['user_type'])==0){
                    wpestate_register_as_user($user_name,$user_id);
                }
            }
             
        } else {
            echo json_encode(array('register'=>false,'message'=>esc_html__( 'Username already exists.  Please choose a new one!','wprentals_sms')));
        }
        die(); 
              
    }
	
	
	function wpestate_ajax_forgot_pass(){
        global $wpdb;

        //    check_ajax_referer( 'login_ajax_nonce', 'security-forgot' );
        $allowed_html   =   array();
        $post_id        =   intval( $_POST['postid'] ) ;
        $forgot_email   =   sanitize_text_field( wp_kses( $_POST['forgot_email'],$allowed_html) ) ;
        $type           =   intval($_POST['type']);
       
        if($type==1){
            check_ajax_referer( 'login_ajax_nonce_forgot_wd',  'security-forgot' );
        }
        if($type==2){
            check_ajax_referer( 'forgot_ajax_nonce',  'security-forgot' );
        }
        if($type==3){
            check_ajax_referer( 'login_ajax_nonce_forgot_wd', 'security-forgot');
        }
        if($type==4){
            check_ajax_referer( 'login_ajax_nonce_forgot_mobile', 'security-forgot');
        }        
        
        if ($forgot_email==''){      
            echo esc_html_e('Mobile field is empty!','wprentals_sms');   
            exit();
        }
		
		if ( !preg_match("/^09[0-9]{9}$/", $forgot_email) ) {
			echo __( 'The mobile doesn\'t look right!','wprentals_sms');
            exit();
		}
		
		$args = array(
			'meta_key'		=> 'mobile',
			'meta_value'	=> $forgot_email,
		); 
		$user_mobile_exist = get_users( $args );
		
		if ( !$user_mobile_exist && !sizeof($user_mobile_exist) > 0 ) {
			echo __('Invalid Mobile Number!','wprentals_sms');
            exit();
		} else {
			$user_data = $user_mobile_exist[0];
		}
		
        $user_mobile    =   get_the_author_meta( 'mobile' , $user_data->ID );
		
		$random_password = wp_generate_password( $length=12, $include_standard_special_chars=false );
		
		wp_set_password( $random_password, $user_data->ID );
		
		//$sms_text = __('Your New Password is: PASS','wprentals_sms');
		//$sms_text = str_replace('PASS', $random_password, $sms_text );
		$sitename = get_option('blogname');
		$sms_text = 'patterncode:4v943z4ccn;pass:'.$random_password.';company:'.$sitename;
				
		$sms_result = rangine_rental_send_sms_register($user_mobile, $sms_text);
		
        echo '<div>'.esc_html__( 'We have just sent you a sms with new Password.','wprentals_sms').'</div>';
        
        die();           
    }

	function rangine_rental_send_sms_register($to,$body){
    	$response = false;
	$username = trim(esc_html( wprentals_get_option('wp_estate_twilio_api_key') ));
	$password = trim(esc_html( wprentals_get_option('wp_estate_twilio_auth_token') ));
	$from     = trim(esc_html( wprentals_get_option('wp_estate_twilio_phone_no') ));
    
    	if ( empty( $username ) || empty( $password ) || empty( $from ) ) {
    		return $response;
    	}
    
    	$massage  = strip_tags($body);
    
    	$to       = array($to);
    
    	if (substr( $massage, 0, 11 ) === "patterncode"){
			$massage = str_replace("r\n",';',$massage);
			$massage = str_replace("\n",';',$massage);
    		$splited = explode(';', $massage);
    		$patterncodeArray = explode(':', $splited[0]);
    		$patterncode = $patterncodeArray[1];
    		unset($splited[0]);
    		$input_data = array();
    		foreach($splited as $parm){
    		  $splited_parm = explode(':', $parm);
    		  $input_data[$splited_parm[0]] = $splited_parm[1];
    		}
			foreach($to as $toNum){
				$reciver = array($toNum);
				$url = "http://sms.rangine.ir/patterns/pattern?username=".$username."&password=".urlencode($password)."&from=$from&to=".json_encode($reciver)."&input_data=".urlencode(json_encode($input_data))."&pattern_code=$patterncode";
				$param = array();
				$handler = curl_init($url);  
				curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
				curl_setopt($handler, CURLOPT_TIMEOUT, 20);			
				curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
				curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
				curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
				$result = curl_exec($handler);
				$resultarray = json_decode($result);
				if (is_array($resultarray) && $resultarray[0] != 'sent') {
					$res_code = $resultarray[0];
					$res_data = $resultarray[1];
					$errorCodes = array(
						'962' => "The username or password is incorrect!",
						'971' => "Patterns is not available!",
						'970' => "Parameters are incorrect!",
						'972' => "The reciver number is not correct!",
					);
					error_log('Rangine SMS Failed. Reason: '.$errorCodes[$res_code]);
					if(isset($errorCodes[$res_code])) $response = $errorCodes[$res_code]; else $response = $res_data;
				}else{
					$response = true;
				}
			}
    	}else{
    		$url = "sms.rangine.ir/services.jspd";
    		$param = array
    					(
    						'uname'=>$username,
    						'pass'=>$password,
    						'from'=>$from,
    						'message'=>$massage,
    						'to'=>json_encode($to),
    						'op'=>'send'
    					);
    					
    		$handler = curl_init($url);    
    		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
    		curl_setopt($handler, CURLOPT_TIMEOUT, 20);			
    		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
    		curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
    		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
    		$result = curl_exec($handler);
    		$result2 = json_decode($result);
    		$res_code = $result2[0];
    		$res_data = $result2[1];
    		if ($res_code == '0'){
    			$response = true;
    		} else {
    			error_log('Rangine SMS Failed. Reason: '.$res_data);
    			$response = false;
    		}
    	}
//$rangine_debug_file = file_get_contents('rangine_debug_file.txt');
//file_put_contents('rangine_debug_file.txt',$rangine_debug_file."\n wprental-sms-register: ".$massage.'-'.$to.' - '.$result); 
    	return $response;
    }
}
add_action( 'admin_enqueue_scripts', 'wprental_sms_rangine_scripts' );
function wprental_sms_rangine_scripts( $hook ) {
	if ( is_admin() && isset($_GET['page']) &&  $_GET['page'] == 'WpRentalsChildtheme' ) {
		wp_register_script( 'wprental_sms_rangine', plugins_url('/rangine.js', __FILE__), array( 'jquery' ), null, false );
		
		$jsData = array(
			'ajax_url' => admin_url( 'admin-ajax.php' ),
		);
		wp_localize_script( 'wprental_sms_rangine', 'wprental_sms_rangine', $jsData );
		wp_enqueue_script( 'wprental_sms_rangine' );
	}
}

add_action( 'wp_ajax_wprental_rangine_CheckPattern', 'wprentalrangineCheckPattern' );

function wprentalrangineCheckPattern(){
	if(isset($_POST['patternCode'])){
		$params = array(
			'uname'=> trim(esc_html( wprentals_get_option('wp_estate_twilio_api_key') )),
			'pass'=> trim(esc_html( wprentals_get_option('wp_estate_twilio_auth_token') )),
			'patternCode'=> esc_html($_POST['patternCode']),
			'op'=> 'getPatternParams',
		);
		$url = "sms.rangine.ir/api/select";
		$handler = curl_init($url);    
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);			
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
		curl_setopt($handler, CURLOPT_POSTFIELDS, json_encode($params));                       
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$response = json_decode(curl_exec($handler),true);
		echo json_encode($response);
	}else{
		echo '-1';
	}
	wp_die();
}