<?php
/*
Plugin Name: WP Rental SMS Plugin For Rangine.ir Gateway
Plugin URI: http://rangine.ir
Description: add rangine sms to wprental theme.
Author: Hadi Mollaei
Version: 2.3
Author URI: http://rangine.ir
*/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

function wpestate_select_sms_type($user_mobile,$type,$arguments,$user_email, $user_data_id){
	$current_user	= wp_get_current_user();
	$userID			=   $current_user->ID;

	$sms_verification =esc_html( wprentals_get_option('wp_estate_sms_verification',''));
	if($sms_verification!=='yes'){
		return;
	}
        
	if($user_data_id!=0 && $type!='validation'){
		$roles=array('administrator');
		if( array_intersect($roles, $current_user->roles )){
			//is admin - do not check
		}else{
			$check_phone = get_the_author_meta( 'check_phone_valid' , $user_data_id);
			if($check_phone!='yes'){
				return;
			}
		}
	}      
	
	$value	=   esc_html( wprentals_get_option('wp_estate_'.$type) );
	if (function_exists('icl_translate') ){
		$value	=  icl_translate('wpestate','wp_estate_sms_'.$value, $value ) ;
	}

	wpestate_sms_filter_replace($user_mobile,$value,$arguments,$user_email);

}

function  wpestate_sms_filter_replace($user_phone_no,$message,$arguments,$user_email){
	$arguments ['website_url'] = get_option('siteurl');
	$arguments ['website_name'] = get_option('blogname');       
	$arguments ['user_email'] = $user_email;     
	$user= get_user_by('email',$user_email);
	$arguments ['username'] = $user-> user_login;

        
	foreach($arguments as $key_arg=>$arg_val){
	           
		$to_replace =   trim('%'.$key_arg);
		 //echo $message.'<br>';
		 //echo $to_replace.'<br>';
		 //echo $arg_val.'<br>';
		  
		$message    =   str_replace($to_replace, $arg_val, $message);
		 //echo $message.'<br>';
	}   
	//exit;
	$response= rangine_rental_send_sms($user_phone_no, $message );    

}

function rangine_rental_send_sms($to,$body){

	$response = false;
	$username = trim(esc_html( wprentals_get_option('wp_estate_twilio_api_key') ));
	$password = trim(esc_html( wprentals_get_option('wp_estate_twilio_auth_token') ));
	$from     = trim(esc_html( wprentals_get_option('wp_estate_twilio_phone_no') ));

	if ( empty( $username ) || empty( $password ) || empty( $from ) ) {
		return $response;
	}

	$massage  = str_replace(array('https://','http://','www.'), array('','',''), strip_tags($body));
	
	$toArray       = explode(';',$to);

	if (substr( $massage, 0, 11 ) === "patterncode"){
		$massage = str_replace("r\n",';',$massage);
		$massage = str_replace("\n",';',$massage);
		$massage = str_replace("\r",';',$massage);
		$splited = explode(';', $massage);
		$patterncodeArray = explode(':', $splited[0]);
		$patterncode = $patterncodeArray[1];
		unset($splited[0]);
		$input_data = array();
		foreach($splited as $parm){
		  $splited_parm = explode(':', $parm);
		  $input_data[$splited_parm[0]] = $splited_parm[1];
		}
		foreach($toArray as $toNum){
			$reciver = array($toNum);
			$url = "sms.rangine.ir/patterns/pattern?username=".$username."&password=".urlencode($password)."&from=$from&to=".json_encode($reciver)."&input_data=".urlencode(json_encode($input_data))."&pattern_code=".$patterncode;
			$handler = curl_init($url);  
			curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 15); 
			curl_setopt($handler, CURLOPT_TIMEOUT, 30);			
			curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "GET");
			curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
			$result = curl_exec($handler);
			$resultarray = json_decode($result);
			if (is_array($resultarray) && $resultarray[0] != 'sent') {
				$res_code = $resultarray[0];
				$res_data = $resultarray[1];
				$errorCodes = array(
					'962' => "The username or password is incorrect!",
					'971' => "Patterns is not available!",
					'970' => "Parameters are incorrect!",
					'972' => "The reciver number is not correct!",
				);
				error_log('Rangine SMS Failed. Reason: '.$errorCodes[$res_code]);
				if(isset($errorCodes[$res_code])) $response = $errorCodes[$res_code]; else $response = $res_data;
			}else{
				$response = true;
			}
		}
	}else{
		$url = "sms.rangine.ir/services.jspd";
		$param = array
					(
						'uname'=>$username,
						'pass'=>$password,
						'from'=>$from,
						'message'=>$massage,
						'to'=>json_encode($to),
						'op'=>'send'
					);
					
		$handler = curl_init($url);    
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);			
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
		curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($handler);
		$result2 = json_decode($result);
		$res_code = $result2[0];
		$res_data = $result2[1];
		if ($res_code == '0'){
			$response = true;
		} else {
			error_log('Rangine SMS Failed. Reason: '.$res_data);
			$response = $res_data;
		}
	}
//$rangine_debug_file = @file_get_contents('rangine_debug_file.txt');
//file_put_contents('rangine_debug_file.txt',$rangine_debug_file."\n wprental-sms: ".$massage." - ".$to." - ".$result);
//echo "wprental-sms: ".json_encode($to).' - '.$result;

	return $response;
}

add_action( 'wp_ajax_rental_sms_test', 'wp_ajax_rental_sms_test');
function wp_ajax_rental_sms_test(){
    $phone = $_POST['phone'];
    $body = $_POST['body'];
    echo rangine_rental_send_sms($phone,$body);
    die();
}
